<?php
namespace bwdads_swiperslider_namespace;

use bwdads_swiperslider_namespace\PageSettings\Page_Settings;
define( "BWDADS_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "BWDADS_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdadsswiperslider {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdads_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdads_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdads_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdads_swiperslider_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdads-slider-widget.php' );
	}

	public function bwdads_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdadsswiperslider_widgets());
	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/bwdads-slider-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function bwdads_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdads-swiperslider-category',
			[
				'title' => esc_html__( 'Advanced Effective Slider', 'bwdads-swiper-td' ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdads_all_assets_for_the_public(){

		wp_enqueue_script( 'swiperslider-swiper', plugin_dir_url( __FILE__ ) . 'assets/public/js/swiper-bundle.min.js', array('jquery'), '1.3', true );

		wp_enqueue_script( 'swiperslider-main-interactive', plugin_dir_url( __FILE__ ) . 'assets/public/js/main.js', array('jquery'), '1.3', true );

		$all_css_file = array(

            'swiperslider-plugin-swiper-style' => array('bwdads_swiperslider_css_path_define'=>BWDADS_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/swiper-bundle.min.css'),

            'swiperslider-plugin-animated' => array('bwdads_swiperslider_css_path_define'=>BWDADS_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/animate.min.css'),

            'swiperslider-plugin-main-style' => array('bwdads_swiperslider_css_path_define'=>BWDADS_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),

        );
        foreach($all_css_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdads_swiperslider_css_path_define'], null, '1.3', 'all');
        }

	}

	//admin-icon
	public function bwdads_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'swiperslider-admin-icon' => array('bwdads_path_admin_define'=>BWDADS_ASFSK_ASSETS_ADMIN_DIR_FILE . '/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdads_path_admin_define'], null, '1.3', 'all');
        }
	}
	
	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdads_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdads_all_assets_for_elementor_editor_admin']);
		
		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdads_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdads_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdads_admin_editor_scripts' ] );
		
		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
Classbwdadsswiperslider::instance();