<?php
namespace bwdads_swiperslider_namespace\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class bwdadsswiperslider_widgets extends Widget_Base {

	public function get_name() {
		return esc_html__( 'bwdads-swiperslider', 'bwdads-swiper-td' );
	}

	public function get_title() {
		return esc_html__( 'Advanced Effective Slider', 'bwdads-swiper-td' );
	}

	public function get_icon() {
		return 'eicon-slider-full-screen bwdads-swiperslider-icon';
	}

	public function get_categories() {
		return [ 'bwdads-swiperslider-category' ];
	}

	protected function register_controls(){

		$this->start_controls_section(
			'bwdads_slider_contents',
			[
				'label' => esc_html__( 'Slider Content', 'bwdads-swiper-td' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);

		$bwdads_slides1 = new \Elementor\Repeater();

		//content-animation
		$bwdads_slides1->add_control(
            'bwdads_contanimation_popover',
            [
                'label' => __('Slide Content Animation', 'bwdads-swiper-td'),
                'type' => Controls_Manager::POPOVER_TOGGLE,
                'label_off' => __('None', 'bwdads-swiper-td'),
                'label_on' => __('Custom', 'bwdads-swiper-td'),
                'return_value' => 'yes',
            ]
        );
		$bwdads_slides1->start_popover();

			//content amination
			$bwdads_slides1->add_control(
				'bwdads_content_animations',
				[
					'label'     => esc_html__('Animation Type', 'bwdads-swiper-td'),
					'type'      => Controls_Manager::SELECT,
					'options'   => [
						'none' => esc_html__('None', 'bwdads-swiper-td'),
						'animate__bounce' => esc_html__('Bounce', 'bwdads-swiper-td'),
						'animate__bounceIn' => esc_html__('BounceIn', 'bwdads-swiper-td'),
						'animate__bounceOut' => esc_html__('BounceOut', 'bwdads-swiper-td'),
						'animate__bounceInUp' => esc_html__('bounceInUp', 'bwdads-swiper-td'),
						'animate__bounceInDown' => esc_html__('bounceInDown', 'bwdads-swiper-td'),
						'animate__bounceInLeft' => esc_html__('bounceInLeft', 'bwdads-swiper-td'),
						'animate__bounceInRight' => esc_html__('bounceInRight', 'bwdads-swiper-td'),
						'animate__backInUp' => esc_html__('backInUp', 'bwdads-swiper-td'),
						'animate__backInDown' => esc_html__('backInDown', 'bwdads-swiper-td'),
						'animate__backInLeft' => esc_html__('backInLeft', 'bwdads-swiper-td'),
						'animate__backInRight' => esc_html__('backInRight', 'bwdads-swiper-td'),
						'animate__flip' => esc_html__('Flip', 'bwdads-swiper-td'),
						'animate__flipInX' => esc_html__('FlipInX', 'bwdads-swiper-td'),
						'animate__flipInY' => esc_html__('FlipInY', 'bwdads-swiper-td'),
						'animate__fadeIn' => esc_html__('fadeIn', 'bwdads-swiper-td'),
						'animate__fadeOut' => esc_html__('FadeOut', 'bwdads-swiper-td'),
						'animate__fadeInUp' => esc_html__('fadeInUp', 'bwdads-swiper-td'),
						'animate__fadeInDown' => esc_html__('fadeInDown', 'bwdads-swiper-td'),
						'animate__fadeInUpBig' => esc_html__('fadeInUpBig', 'bwdads-swiper-td'),
						'animate__fadeInLeft' => esc_html__('fadeInLeft', 'bwdads-swiper-td'),
						'animate__fadeInRight' => esc_html__('fadeInRight', 'bwdads-swiper-td'),
						'animate__fadeInRightBig' => esc_html__('fadeInRightBig', 'bwdads-swiper-td'),
						'animate__fadeInBottomRight' => esc_html__('fadeInBottomRight', 'bwdads-swiper-td'),
						'animate__fadeInBottomLeft' => esc_html__('fadeInBottomLeft', 'bwdads-swiper-td'),
						'animate__fadeInTopRight' => esc_html__('fadeInTopRight', 'bwdads-swiper-td'),
						'animate__fadeInTopLeft' => esc_html__('fadeInTopLeft', 'bwdads-swiper-td'),
						'animate__rotateIn' => esc_html__('RotateIn', 'bwdads-swiper-td'),
						'animate__rotateOut' => esc_html__('RotateOut', 'bwdads-swiper-td'),
						'animate__rotateInUpRight' => esc_html__('rotateInUpRight', 'bwdads-swiper-td'),
						'animate__rotateInUpLeft' => esc_html__('rotateInUpLeft', 'bwdads-swiper-td'),
						'animate__rotateInDownRight' => esc_html__('rotateInDownRight', 'bwdads-swiper-td'),
						'animate__rotateInDownLeft' => esc_html__('rotateInDownLeft', 'bwdads-swiper-td'),
						'animate__hinge' => esc_html__('Hinge', 'bwdads-swiper-td'),
						'animate__zoomIn' => esc_html__('ZoomIn', 'bwdads-swiper-td'),
						'animate__zoomOut' => esc_html__('ZoomOut', 'bwdads-swiper-td'),
						'animate__zoomInUp' => esc_html__('zoomInUp', 'bwdads-swiper-td'),
						'animate__zoomInRight' => esc_html__('zoomInRight', 'bwdads-swiper-td'),
						'animate__zoomInLeft' => esc_html__('zoomInLeft', 'bwdads-swiper-td'),
						'animate__zoomInDown' => esc_html__('zoomInDown', 'bwdads-swiper-td'),
						'animate__slideInUp' => esc_html__('SlideInUp', 'bwdads-swiper-td'),
						'animate__slideInRight' => esc_html__('slideInRight', 'bwdads-swiper-td'),
						'animate__slideInLeft' => esc_html__('slideInLeft', 'bwdads-swiper-td'),
						'animate__slideInDown' => esc_html__('slideInDown', 'bwdads-swiper-td'),
						'animate__flash' => esc_html__('Flash', 'bwdads-swiper-td'),
						'animate__rollIn' => esc_html__('rollIn', 'bwdads-swiper-td'),
						'animate__pulse' => esc_html__('Pulse', 'bwdads-swiper-td'),
						'animate__rubberBand' => esc_html__('RubberBand', 'bwdads-swiper-td'),
						'animate__shakeX' => esc_html__('ShakeX', 'bwdads-swiper-td'),
						'animate__shakeY' => esc_html__('ShakeY', 'bwdads-swiper-td'),
						'animate__headShake' => esc_html__('HeadShake', 'bwdads-swiper-td'),
						'animate__swing' => esc_html__('Swing', 'bwdads-swiper-td'),
						'animate__tada' => esc_html__('Tada', 'bwdads-swiper-td'),
						'animate__wobble' => esc_html__('Wobble', 'bwdads-swiper-td'),
						'animate__jello' => esc_html__('Jello', 'bwdads-swiper-td'),
						'animate__heartBeat' => esc_html__('HeartBeat', 'bwdads-swiper-td'),
						'animate__jackInTheBox' => esc_html__('JackInTheBox', 'bwdads-swiper-td'),
						'animate__lightSpeedInLeft' => esc_html__('lightSpeedInLeft', 'bwdads-swiper-td'),
						'animate__lightSpeedInRight' => esc_html__('lightSpeedInRight', 'bwdads-swiper-td'),
					],
					'default' => 'animate__fadeInUp',
				]
			);

			//content_animation_speed
			$bwdads_slides1->add_control(
				'bwdads_content_animation_speed',
				[
					'label' => __('Animation Speed (ms)', 'bwdads-swiper-td'),
					'type' => Controls_Manager::SLIDER,
					'size_units' => ['ms'],
					'range' => [
						'ms' => [
							'min' => 100,
							'max' => 5000,
							'step' => 50,
						],
					],
					'default' => [
						'unit' => 'ms',
						'size' => 1250,
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwdads-slide-content' => 'animation-duration: {{SIZE}}{{UNIT}};',
					],
				]
			);

		$bwdads_slides1->end_popover();

		//image-animation
		$bwdads_slides1->add_control(
            'bwdads_imganimation_popover',
            [
                'label' => __('Slide Image Animation', 'bwdads-swiper-td'),
                'type' => Controls_Manager::POPOVER_TOGGLE,
                'label_off' => __('None', 'bwdads-swiper-td'),
                'label_on' => __('Custom', 'bwdads-swiper-td'),
                'return_value' => 'yes',
				'condition' => [
					'bwdads_slider1_img_switcher' => 'yes',
				],
            ]
        );
		$bwdads_slides1->start_popover();

			//image amination
			$bwdads_slides1->add_control(
				'bwdads_img_animations',
				[
					'label'     => esc_html__('Animation Type', 'bwdads-swiper-td'),
					'type'      => Controls_Manager::SELECT,
					'options'   => [
						'none' => esc_html__('None', 'bwdads-swiper-td'),
						'animate__bounce' => esc_html__('Bounce', 'bwdads-swiper-td'),
						'animate__bounceIn' => esc_html__('BounceIn', 'bwdads-swiper-td'),
						'animate__bounceOut' => esc_html__('BounceOut', 'bwdads-swiper-td'),
						'animate__bounceInUp' => esc_html__('bounceInUp', 'bwdads-swiper-td'),
						'animate__bounceInDown' => esc_html__('bounceInDown', 'bwdads-swiper-td'),
						'animate__bounceInLeft' => esc_html__('bounceInLeft', 'bwdads-swiper-td'),
						'animate__bounceInRight' => esc_html__('bounceInRight', 'bwdads-swiper-td'),
						'animate__backInUp' => esc_html__('backInUp', 'bwdads-swiper-td'),
						'animate__backInDown' => esc_html__('backInDown', 'bwdads-swiper-td'),
						'animate__backInLeft' => esc_html__('backInLeft', 'bwdads-swiper-td'),
						'animate__backInRight' => esc_html__('backInRight', 'bwdads-swiper-td'),
						'animate__flip' => esc_html__('Flip', 'bwdads-swiper-td'),
						'animate__flipInX' => esc_html__('FlipInX', 'bwdads-swiper-td'),
						'animate__flipInY' => esc_html__('FlipInY', 'bwdads-swiper-td'),
						'animate__fadeIn' => esc_html__('fadeIn', 'bwdads-swiper-td'),
						'animate__fadeOut' => esc_html__('FadeOut', 'bwdads-swiper-td'),
						'animate__fadeInUp' => esc_html__('fadeInUp', 'bwdads-swiper-td'),
						'animate__fadeInDown' => esc_html__('fadeInDown', 'bwdads-swiper-td'),
						'animate__fadeInUpBig' => esc_html__('fadeInUpBig', 'bwdads-swiper-td'),
						'animate__fadeInLeft' => esc_html__('fadeInLeft', 'bwdads-swiper-td'),
						'animate__fadeInRight' => esc_html__('fadeInRight', 'bwdads-swiper-td'),
						'animate__fadeInRightBig' => esc_html__('fadeInRightBig', 'bwdads-swiper-td'),
						'animate__fadeInBottomRight' => esc_html__('fadeInBottomRight', 'bwdads-swiper-td'),
						'animate__fadeInBottomLeft' => esc_html__('fadeInBottomLeft', 'bwdads-swiper-td'),
						'animate__fadeInTopRight' => esc_html__('fadeInTopRight', 'bwdads-swiper-td'),
						'animate__fadeInTopLeft' => esc_html__('fadeInTopLeft', 'bwdads-swiper-td'),
						'animate__rotateIn' => esc_html__('RotateIn', 'bwdads-swiper-td'),
						'animate__rotateOut' => esc_html__('RotateOut', 'bwdads-swiper-td'),
						'animate__rotateInUpRight' => esc_html__('rotateInUpRight', 'bwdads-swiper-td'),
						'animate__rotateInUpLeft' => esc_html__('rotateInUpLeft', 'bwdads-swiper-td'),
						'animate__rotateInDownRight' => esc_html__('rotateInDownRight', 'bwdads-swiper-td'),
						'animate__rotateInDownLeft' => esc_html__('rotateInDownLeft', 'bwdads-swiper-td'),
						'animate__hinge' => esc_html__('Hinge', 'bwdads-swiper-td'),
						'animate__zoomIn' => esc_html__('ZoomIn', 'bwdads-swiper-td'),
						'animate__zoomOut' => esc_html__('ZoomOut', 'bwdads-swiper-td'),
						'animate__zoomInUp' => esc_html__('zoomInUp', 'bwdads-swiper-td'),
						'animate__zoomInRight' => esc_html__('zoomInRight', 'bwdads-swiper-td'),
						'animate__zoomInLeft' => esc_html__('zoomInLeft', 'bwdads-swiper-td'),
						'animate__zoomInDown' => esc_html__('zoomInDown', 'bwdads-swiper-td'),
						'animate__slideInUp' => esc_html__('SlideInUp', 'bwdads-swiper-td'),
						'animate__slideInRight' => esc_html__('slideInRight', 'bwdads-swiper-td'),
						'animate__slideInLeft' => esc_html__('slideInLeft', 'bwdads-swiper-td'),
						'animate__slideInDown' => esc_html__('slideInDown', 'bwdads-swiper-td'),
						'animate__flash' => esc_html__('Flash', 'bwdads-swiper-td'),
						'animate__rollIn' => esc_html__('rollIn', 'bwdads-swiper-td'),
						'animate__pulse' => esc_html__('Pulse', 'bwdads-swiper-td'),
						'animate__rubberBand' => esc_html__('RubberBand', 'bwdads-swiper-td'),
						'animate__shakeX' => esc_html__('ShakeX', 'bwdads-swiper-td'),
						'animate__shakeY' => esc_html__('ShakeY', 'bwdads-swiper-td'),
						'animate__headShake' => esc_html__('HeadShake', 'bwdads-swiper-td'),
						'animate__swing' => esc_html__('Swing', 'bwdads-swiper-td'),
						'animate__tada' => esc_html__('Tada', 'bwdads-swiper-td'),
						'animate__wobble' => esc_html__('Wobble', 'bwdads-swiper-td'),
						'animate__jello' => esc_html__('Jello', 'bwdads-swiper-td'),
						'animate__heartBeat' => esc_html__('HeartBeat', 'bwdads-swiper-td'),
						'animate__jackInTheBox' => esc_html__('JackInTheBox', 'bwdads-swiper-td'),
						'animate__lightSpeedInLeft' => esc_html__('lightSpeedInLeft', 'bwdads-swiper-td'),
						'animate__lightSpeedInRight' => esc_html__('lightSpeedInRight', 'bwdads-swiper-td'),
					],
					'default'   => 'animate__slideInRight',
				]
			);

			//image_animation_speed
			$bwdads_slides1->add_control(
				'bwdads_img_animation_speed',
				[
					'label' => __('Animation Speed (ms)', 'bwdads-swiper-td'),
					'type' => Controls_Manager::SLIDER,
					'size_units' => ['ms'],
					'range' => [
						'ms' => [
							'min' => 100,
							'max' => 5000,
							'step' => 50,
						],
					],
					'default' => [
						'unit' => 'ms',
						'size' => 1250,
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwdads-slide-img' => 'animation-duration: {{SIZE}}{{UNIT}};',
					],
				]
			);

		$bwdads_slides1->end_popover();

		//common
		$bwdads_slides1->add_control(
            'bwdads_common_popover',
            [
                'label' => __('Common', 'bwdads-swiper-td'),
                'type' => Controls_Manager::POPOVER_TOGGLE,
                'label_off' => __('None', 'bwdads-swiper-td'),
                'label_on' => __('Custom', 'bwdads-swiper-td'),
                'return_value' => 'yes',
            ]
        );
		$bwdads_slides1->start_popover();

			//horizontal-alignment
			$bwdads_slides1->add_responsive_control(
				'bwdads_slide1_horizontal_align',
				[
					'label' => esc_html__( 'Horizontal Alignment', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::CHOOSE,
					'options' => [
						'start' => [
							'title' => esc_html__( 'Left', 'bwdads-swiper-td' ),
							'icon' => ' eicon-h-align-left',
						],
						'center' => [
							'title' => esc_html__( 'Center', 'bwdads-swiper-td' ),
							'icon' => 'eicon-h-align-center',
						],
						'end' => [
							'title' => esc_html__( 'Right', 'bwdads-swiper-td' ),
							'icon' => 'eicon-h-align-right',
						],
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}}.bwd_content-wrap' => 'justify-content: {{VALUE}}',
					],
					'toggle' => true,
				]
			);

			//vertical-alignment
			$bwdads_slides1->add_responsive_control(
				'bwdads_slide1_vertical_align',
				[
					'label' => esc_html__( 'Vertical Alignment', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::CHOOSE,
					'options' => [
						'start' => [
							'title' => esc_html__( 'Top', 'bwdads-swiper-td' ),
							'icon' => 'eicon-v-align-top',
						],
						'center' => [
							'title' => esc_html__( 'Center', 'bwdads-swiper-td' ),
							'icon' => 'eicon-v-align-middle',
						],
						'end' => [
							'title' => esc_html__( 'Bottom', 'bwdads-swiper-td' ),
							'icon' => ' eicon-v-align-bottom',
						],
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}}.bwd_content-wrap' => 'align-items: {{VALUE}}',
					],
					'toggle' => true,
				]
			);

			//content-box-width
			$bwdads_slides1->add_responsive_control(
				'bwdads_box-width',
				[
					'label' => esc_html__( 'Content Box Width (%)', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ '%', 'px' ],
					'range' => [
						'%' => [
							'min' => 0,
							'max' => 100,
						],
						'px' => [
							'min' => 0,
							'max' => 10000,
							'step' => 1,
						],
					],
					'default' => [
						'unit' => '%',
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_main-content' => 'width: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//image-box-width
			$bwdads_slides1->add_responsive_control(
				'bwdads_imgbox-width',
				[
					'label' => esc_html__( 'Image Box Width (%)', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ '%', 'px' ],
					'range' => [
						'%' => [
							'min' => 0,
							'max' => 100,
						],
						'px' => [
							'min' => 0,
							'max' => 10000,
							'step' => 1,
						],
					],
					'default' => [
						'unit' => '%',
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd-slider-image' => 'width: {{SIZE}}{{UNIT}};',
					],
					'condition' => [
						'bwdads_slider1_img_switcher' => 'yes',
					],
				]
			);
			
			//text alignment
			$bwdads_slides1->add_responsive_control(
				'bwdads_slide1_text_align',
				[
					'label' => esc_html__( 'Text Alignment', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::CHOOSE,
					'options' => [
						'left' => [
							'title' => esc_html__( 'Left', 'bwdads-swiper-td' ),
							'icon' => 'eicon-text-align-left',
						],
						'center' => [
							'title' => esc_html__( 'Center', 'bwdads-swiper-td' ),
							'icon' => 'eicon-text-align-center',
						],
						'right' => [
							'title' => esc_html__( 'Right', 'bwdads-swiper-td' ),
							'icon' => 'eicon-text-align-right',
						],
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}}.bwd_main-content' => 'text-align: {{VALUE}}',
					],
					'toggle' => true,
				]
			);

			//image alignment
			$bwdads_slides1->add_responsive_control(
				'bwdads_slide1_img_align',
				[
					'label' => esc_html__( 'Image Alignment', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::CHOOSE,
					'options' => [
						'left' => [
							'title' => esc_html__( 'Left', 'bwdads-swiper-td' ),
							'icon' => 'eicon-text-align-left',
						],
						'center' => [
							'title' => esc_html__( 'Center', 'bwdads-swiper-td' ),
							'icon' => 'eicon-text-align-center',
						],
						'right' => [
							'title' => esc_html__( 'Right', 'bwdads-swiper-td' ),
							'icon' => 'eicon-text-align-right',
						],
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd-slider-image' => 'text-align: {{VALUE}}',
					],
					'condition' => [
						'bwdads_slider1_img_switcher' => 'yes',
					],
					'toggle' => true,
				]
			);

		$bwdads_slides1->end_popover();

		//row_column_direction
		$bwdads_slides1->add_responsive_control(
			'bwdads_row_column_direction',
			[
				'label' => esc_html__( 'Row/Column Direction', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => '',
				'options' => [
					'row'  => esc_html__( 'Row', 'bwdads-swiper-td' ),
					'column'  => esc_html__( 'Column', 'bwdads-swiper-td' ),
					'row-reverse'  => esc_html__( 'Row Reverse', 'bwdads-swiper-td' ),
					'column-reverse'  => esc_html__( 'Column Reverse', 'bwdads-swiper-td' ),
				],
				'selectors'   => [
                    '{{WRAPPER}} {{CURRENT_ITEM}} .bwd_content-wrap' => 'flex-direction: {{value}}',
                ],
				'condition' => [
					'bwdads_slider1_img_switcher' => 'yes',
				],
			]
		);


		//tabs------------------------------------------
		$bwdads_slides1->start_controls_tabs(
			'style_tabs',
		);

		//highlight-background-style------------------------------------------
		$bwdads_slides1->start_controls_tab(
			'style_background_tab',
			[
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
			]
		);

		$bwdads_slides1->add_control(
			'bwdads_slide1_bgtype',
			[
				'label' => esc_html__( 'Image/Color', 'bwdads-swiper-td' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'image',
				'options' => [
					'image' => esc_html__( 'Image', 'bwdads-swiper-td' ),
					'color' => esc_html__( 'Color', 'bwdads-swiper-td' ),
				],
			]
		);

		//slider-background
		$bwdads_slides1->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdads_slide1_image',
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'types' => [ 'classic'],
				'exclude' => [ 'color'],
				'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}.bwd_single_slider',
				'condition' => [
					'bwdads_slide1_bgtype' => 'image',
				],
			]
		);

		$bwdads_slides1->add_control(
			'bwdads_slide1_bgcolor',
			[
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} {{CURRENT_ITEM}}.bwd_single_slider' => 'background: {{VALUE}}',
				],
				'condition' => [
					'bwdads_slide1_bgtype' => 'color',
				],
			]
		);

		//bg-image-overlay
		$bwdads_slides1->add_control(
			'bwdads_slider1_bg_overlay',
			[
				'label' => esc_html__( 'Background Overlay?', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'bwdads-swiper-td' ),
				'label_off' => esc_html__( 'No', 'bwdads-swiper-td' ),
				'return_value' => 'yes',
				'default' => 'no',
			]
		);
		$bwdads_slides1->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdads_slide1_image_ovrly',
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'types' => [ 'classic', 'gradient'],
				'exclude' => [ 'image'],
				'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}.bwd_single_slider::before',
				'condition' => [
					'bwdads_slider1_bg_overlay' => 'yes',
				],
			]
		);

		//image-width
		$bwdads_slides1->add_responsive_control(
			'bwdads_slide1_image_ovrly_width',
			[
				'label' => esc_html__( 'Width', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ '%' ],
				'range' => [
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'default' => [
					'unit' => '%',
					'size' => 100,
				],
				'selectors' => [
					'{{WRAPPER}} {{CURRENT_ITEM}}.bwd_single_slider::before' => 'width: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'bwdads_slider1_bg_overlay' => 'yes',
				],
			]
		);

		//image-height
		$bwdads_slides1->add_responsive_control(
			'bwdads_slide1_image_ovrly_height',
			[
				'label' => esc_html__( 'Height', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ '%' ],
				'range' => [
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'default' => [
					'unit' => '%',
					'size' => 100,
				],
				'selectors' => [
					'{{WRAPPER}} {{CURRENT_ITEM}}.bwd_single_slider::before' => 'height: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'bwdads_slider1_bg_overlay' => 'yes',
				],
			]
		);

		$bwdads_slides1->end_controls_tab();

		//highlight-content-style------------------------------------------
		$bwdads_slides1->start_controls_tab(
			'style_content_tab',
			[
				'label' => esc_html__( 'Content', 'bwdads-swiper-td' ),
			]
		);

		//title
		$bwdads_slides1->add_control(
			'bwdads_slide1_title', 
			[
				'label' => esc_html__( 'Title', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				// 'default' => esc_html__( 'We Provide quality Services' , 'bwdads-swiper-td' ),	
				'label_block' => true,
				'dynamic' => [
					'active' => true,
				],
			]
		);

		//sub-title
		$bwdads_slides1->add_control(
			'bwdads_slide1_sub_title', 
			[
				'label' => esc_html__( 'Sub Title', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				//'default' => esc_html__( 'Quality Wood Work' , 'bwdads-swiper-td' ),	
				'label_block' => true,
				'dynamic' => [
					'active' => true,
				],
			]
		);

		//Description
		$bwdads_slides1->add_control(
			'bwdads_slide1_desce',
			[
				'label' => esc_html__( 'Description', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'rows' => 10,
				//'default' => esc_html__( 'It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters.', 'bwdads-swiper-td' ),
			]
		);

		//slide-button-1
		$bwdads_slides1->add_control(
			'bwdads_slide1_button1_text', 
			[
				'label' => esc_html__( 'First Button', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				//'default' => esc_html__( 'our service' , 'bwdads-swiper-td' ),	
				'label_block' => true,
				'dynamic' => [
					'active' => true,
				],
			]
		);

		//button2 link
		$bwdads_slides1->add_control(
			'bwdads_slide1_button1_link',
			[
				'label' => esc_html__( 'First Button Link', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::URL,
				'placeholder' => esc_html__( 'https://example.com', 'bwdads-swiper-td' ),
				'label_block' => true,
				'show_external' => true,
				'default' => [
                    'url' => 'https://bestwpdeveloper.com/',
                    'is_external' => true,
                    'nofollow' => true,
                ],
				'dynamic' => [
					'active' => true,
				],
				'condition' => [
                    'bwdads_slide1_button1_text!' => '',
                ],
			]
		);

		//slide-button-2
		$bwdads_slides1->add_control(
			'bwdads_slide1_button2_text', 
			[
				'label' => esc_html__( 'Second Button', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => esc_html__( 'our contact' , 'bwdads-swiper-td' ),	
				'label_block' => true,
				'dynamic' => [
					'active' => true,
				],
			]
		);

		//button2 link
		$bwdads_slides1->add_control(
			'bwdads_slide1_button2_link',
			[
				'label' => esc_html__( 'Second Button Link', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::URL,
				'placeholder' => esc_html__( 'https://example.com', 'bwdads-swiper-td' ),
				'label_block' => true,
				'show_external' => true,
				'default' => [
                    'url' => 'https://bestwpdeveloper.com/contact-us',
                    'is_external' => true,
                    'nofollow' => true,
                ],
				'dynamic' => [
					'active' => true,
				],
				'condition' => [
                    'bwdads_slide1_button2_text!' => '',
                ],
			]
		);

		//image-switcher
		$bwdads_slides1->add_control(
			'bwdads_slider1_img_switcher',
			[
				'label' => esc_html__( 'Image?', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Yes', 'bwdads-swiper-td' ),
				'label_off' => esc_html__( 'No', 'bwdads-swiper-td' ),
				'return_value' => 'yes',
				'default' => 'no',
				'separator' => 'before',
			]
		);

		$bwdads_slides1->add_control(
			'bwdads_slidder1_image',
			[
				'label' => esc_html__( 'Choose Image', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::MEDIA,
				'default' => [
					'url' => plugin_dir_url(__DIR__).'assets/public/image/bwd-vector.png',
				],
				'condition' => [
					'bwdads_slider1_img_switcher' => 'yes',
				],
			]
		);

		$bwdads_slides1->end_controls_tab();

		//highlight-style-style------------------------------------------
		$bwdads_slides1->start_controls_tab(
			'style_style_tab',
			[
				'label' => esc_html__( 'Style', 'bwdads-swiper-td' ),
			]
		);

		//content-box-popover
		$bwdads_slides1->add_control(
			'bwdads_contentbox_popover',
			[
				'label' => __('Content Box', 'bwdads-swiper-td'),
				'type' => Controls_Manager::POPOVER_TOGGLE,
				'label_off' => __('None', 'bwdads-swiper-td'),
				'label_on' => __('Custom', 'bwdads-swiper-td'),
				'return_value' => 'yes',
			]
		);
		$bwdads_slides1->start_popover();

			//gradient_bg 
			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Background::get_type(),
				[
					'name' => 'bwdads_content_background',
					'types' => ['classic','gradient'],
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}.bwd_main-content',
				]
			);

			//border
			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Border::get_type(),
				[
					'name' => 'bwdads_slide1_content_border',
					'label' => esc_html__( 'Border', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}.bwd_main-content',
				]
			);

			//Border Radius
			$bwdads_slides1->add_responsive_control(
				'bwdads_slide1_content_radius',
				[
					'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}}.bwd_main-content' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//padding
			$bwdads_slides1->add_responsive_control(
				'bwdads_slide1_content_padding',
				[
					'label' => esc_html__( 'Padding', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}}.bwd_main-content' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//margin
			$bwdads_slides1->add_responsive_control(
				'bwdads_slide1_content_margin',
				[
					'label' => esc_html__( 'Margin', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}}.bwd_main-content' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//Box Shadow
			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Box_Shadow::get_type(),
				[
					'name' => 'bwdads_slide1_content_shadow',
					'label' => esc_html__( 'Box Shadow', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}.bwd_main-content',
				]
			);

		$bwdads_slides1->end_popover();

		//title-popover
		$bwdads_slides1->add_control(
            'bwdads_title_popover',
            [
                'label' => __('Title', 'bwdads-swiper-td'),
                'type' => Controls_Manager::POPOVER_TOGGLE,
                'label_off' => __('None', 'bwdads-swiper-td'),
                'label_on' => __('Custom', 'bwdads-swiper-td'),
                'return_value' => 'yes',
            ]
        );
		$bwdads_slides1->start_popover();

			//title-color
			$bwdads_slides1->add_control(
				'bwdads_title_color',
				[
					'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_main-title' => 'color: {{VALUE}}',
					],
				]
			);
			//title-hover-color
			$bwdads_slides1->add_control(
				'bwdads_title_color_hover',
				[
					'label' => esc_html__( 'Hover Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_main-title:hover' => 'color: {{VALUE}}',
					],
				]
			);

			//title-background
			$bwdads_slides1->add_control(
				'bwdads_title_bg',
				[
					'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_main-title' => 'background: {{VALUE}}',
					],
				]
			);

			//padding
			$bwdads_slides1->add_responsive_control(
				'bwdads_title_padding',
				[
					'label' => esc_html__( 'Padding', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_main-title' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//padding
			$bwdads_slides1->add_responsive_control(
				'bwdads_title_margin',
				[
					'label' => esc_html__( 'Margin', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_main-title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//Border Radius
			$bwdads_slides1->add_responsive_control(
				'bwdads_title_radius',
				[
					'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_main-title' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//text-shadow
			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Text_Shadow::get_type(),
				[
					'name' => 'bwdads_title_shadow',
					'label' => esc_html__( 'Text Shadow', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .bwd_main-title',
				]
			);

			
		
		$bwdads_slides1->end_popover();

		//sub-title-popover
		$bwdads_slides1->add_control(
            'bwdads_subtitle_popover',
            [
                'label' => __('Sub Title', 'bwdads-swiper-td'),
                'type' => Controls_Manager::POPOVER_TOGGLE,
                'label_off' => __('None', 'bwdads-swiper-td'),
                'label_on' => __('Custom', 'bwdads-swiper-td'),
                'return_value' => 'yes',
            ]
        );
		$bwdads_slides1->start_popover();

			//title-color
			$bwdads_slides1->add_control(
				'bwdads_subtitle_color',
				[
					'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-title' => 'color: {{VALUE}}',
					],
				]
			);
			//title-hover-color
			$bwdads_slides1->add_control(
				'bwdads_subtitle_color_hover',
				[
					'label' => esc_html__( 'Hover Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-title:hover' => 'color: {{VALUE}}',
					],
				]
			);

			//title-background
			$bwdads_slides1->add_control(
				'bwdads_subtitle_bg',
				[
					'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-title' => 'background: {{VALUE}}',
					],
				]
			);

			//padding
			$bwdads_slides1->add_responsive_control(
				'bwdads_subtitle_padding',
				[
					'label' => esc_html__( 'Padding', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-title' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//margin
			$bwdads_slides1->add_responsive_control(
				'bwdads_subtitle_margin',
				[
					'label' => esc_html__( 'Margin', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//Border Radius
			$bwdads_slides1->add_responsive_control(
				'bwdads_subtitle_radius',
				[
					'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-title' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//text-shadow
			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Text_Shadow::get_type(),
				[
					'name' => 'bwdads_subtitle_shadow',
					'label' => esc_html__( 'Text Shadow', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-title',
				]
			);

			
		
		$bwdads_slides1->end_popover();

		//desc-popover
		$bwdads_slides1->add_control(
            'bwdads_desc_popover',
            [
                'label' => __('Description', 'bwdads-swiper-td'),
                'type' => Controls_Manager::POPOVER_TOGGLE,
                'label_off' => __('None', 'bwdads-swiper-td'),
                'label_on' => __('Custom', 'bwdads-swiper-td'),
                'return_value' => 'yes',
            ]
        );
		$bwdads_slides1->start_popover();

			//title-color
			$bwdads_slides1->add_control(
				'bwdads_desc_color',
				[
					'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-desc' => 'color: {{VALUE}}',
					],
				]
			);
			//title-hover-color
			$bwdads_slides1->add_control(
				'bwdads_desc_color_hover',
				[
					'label' => esc_html__( 'Hover Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-desc:hover' => 'color: {{VALUE}}',
					],
				]
			);

			//title-background
			$bwdads_slides1->add_control(
				'bwdads_desc_bg',
				[
					'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-desc' => 'background: {{VALUE}}',
					],
				]
			);

			//padding
			$bwdads_slides1->add_responsive_control(
				'bwdads_desc_padding',
				[
					'label' => esc_html__( 'Padding', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-desc' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//margin
			$bwdads_slides1->add_responsive_control(
				'bwdads_desc_margin',
				[
					'label' => esc_html__( 'Margin', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-desc' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//Border Radius
			$bwdads_slides1->add_responsive_control(
				'bwdads_desc_radius',
				[
					'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-desc' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//text-shadow
			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Text_Shadow::get_type(),
				[
					'name' => 'bwdads_desc_shadow',
					'label' => esc_html__( 'Text Shadow', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .bwd_sub-desc',
				]
			);

			
		
		$bwdads_slides1->end_popover();

		//button-1-popover
		$bwdads_slides1->add_control(
            'bwdads_button1_popover',
            [
                'label' => __('First Button', 'bwdads-swiper-td'),
                'type' => Controls_Manager::POPOVER_TOGGLE,
                'label_off' => __('None', 'bwdads-swiper-td'),
                'label_on' => __('Custom', 'bwdads-swiper-td'),
                'return_value' => 'yes',
            ]
        );
		$bwdads_slides1->start_popover();

			//first-button-color
			$bwdads_slides1->add_control(
				'bwdads_FB_color',
				[
					'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button1' => 'color: {{VALUE}}',
					],
				]
			);

			//first-button-hover-color
			$bwdads_slides1->add_control(
				'bwdads_FB_color_hover',
				[
					'label' => esc_html__( 'Hover Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button1:hover' => 'color: {{VALUE}}',
					],
				]
			);

			//first-button-background
			$bwdads_slides1->add_control(
				'bwdads_FB_bg',
				[
					'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button1' => 'background: {{VALUE}}',
					],
				]
			);

			//first-button-hover-background
			$bwdads_slides1->add_control(
				'bwdads_FB_bg_hover',
				[
					'label' => esc_html__( 'Hover Background', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button1:hover' => 'background: {{VALUE}}',
					],
				]
			);

			//first-button-padding
			$bwdads_slides1->add_responsive_control(
				'bwdads_FB_padding',
				[
					'label' => esc_html__( 'Padding', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button1' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//first-button-margin
			$bwdads_slides1->add_responsive_control(
				'bwdads_FB_margin',
				[
					'label' => esc_html__( 'Margin', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button1' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Border::get_type(),
				[
					'name' => 'bwdads_FB_border',
					'label' => esc_html__( 'Border', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button1',
				]
			);

			//first-button-Border Radius
			$bwdads_slides1->add_responsive_control(
				'bwdads_FB_radius',
				[
					'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button1' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//first-button-box-shadow
			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Box_Shadow::get_type(),
				[
					'name' => 'bwdads_FB_shadow',
					'label' => esc_html__( 'Box Shadow', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button1',
				]
			);

		$bwdads_slides1->end_popover();

		//button-2-popover
		$bwdads_slides1->add_control(
            'bwdads_button2_popover',
            [
                'label' => __('Second Button', 'bwdads-swiper-td'),
                'type' => Controls_Manager::POPOVER_TOGGLE,
                'label_off' => __('None', 'bwdads-swiper-td'),
                'label_on' => __('Custom', 'bwdads-swiper-td'),
                'return_value' => 'yes',
            ]
        );
		$bwdads_slides1->start_popover();

			//second-button-color
			$bwdads_slides1->add_control(
				'bwdads_SB_color',
				[
					'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button2' => 'color: {{VALUE}}',
					],
				]
			);

			//second-button-hover-color
			$bwdads_slides1->add_control(
				'bwdads_SB_color_hover',
				[
					'label' => esc_html__( 'Hover Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button2:hover' => 'color: {{VALUE}}',
					],
				]
			);

			//second-button-background
			$bwdads_slides1->add_control(
				'bwdads_SB_bg',
				[
					'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button2' => 'background: {{VALUE}}',
					],
				]
			);

			//second-button-hover-background
			$bwdads_slides1->add_control(
				'bwdads_SB_bg_hover',
				[
					'label' => esc_html__( 'Hover Background', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button2:hover' => 'background: {{VALUE}}',
					],
				]
			);

			//second-button-padding
			$bwdads_slides1->add_responsive_control(
				'bwdads_SB_padding',
				[
					'label' => esc_html__( 'Padding', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button2' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//second-button-margin
			$bwdads_slides1->add_responsive_control(
				'bwdads_SB_margin',
				[
					'label' => esc_html__( 'Margin', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button2' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Border::get_type(),
				[
					'name' => 'bwdads_SB_border',
					'label' => esc_html__( 'Border', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button2',
				]
			);

			//second-button-Border Radius
			$bwdads_slides1->add_responsive_control(
				'bwdads_SB_radius',
				[
					'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button2' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//second-button-box-shadow
			$bwdads_slides1->add_group_control(
				\Elementor\Group_Control_Box_Shadow::get_type(),
				[
					'name' => 'bwdads_SB_shadow',
					'label' => esc_html__( 'Box Shadow', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .bwd_link_btn.bwd-button2',
				]
			);

		$bwdads_slides1->end_popover();

		//image-popover
		$bwdads_slides1->add_control(
            'bwdads_img_popover',
            [
                'label' => __('Image', 'bwdads-swiper-td'),
                'type' => Controls_Manager::POPOVER_TOGGLE,
                'label_off' => __('None', 'bwdads-swiper-td'),
                'label_on' => __('Custom', 'bwdads-swiper-td'),
                'return_value' => 'yes',
            ]
        );
		$bwdads_slides1->start_popover();

			//image-width
			$bwdads_slides1->add_responsive_control(
				'bwdads_img_width',
				[
					'label' => esc_html__( 'Width', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 10000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 100,
						],
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd-img-wrap' => 'width: {{SIZE}}{{UNIT}};',
					],
				]
			);
			//image-height
			$bwdads_slides1->add_responsive_control(
				'bwdads_img_height',
				[
					'label' => esc_html__( 'Height', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 10000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 100,
						],
					],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd-img-wrap' => 'height: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//margin
			$bwdads_slides1->add_responsive_control(
				'bwdads_img_margin',
				[
					'label' => esc_html__( 'Margin', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} {{CURRENT_ITEM}} .bwd-img-wrap' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

		$bwdads_slides1->end_popover();


		$bwdads_slides1->end_controls_tab();
		$bwdads_slides1->end_controls_tabs();

		//slider-repeater
		$this->add_control(
			'bwdads_slide1_repet',
			[
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $bwdads_slides1->get_controls(),
				'default' => [
					[
						'bwdads_slide1_title' => esc_html__( 'We Provide quality Services' , 'bwdads-swiper-td' ),
						'bwdads_slide1_sub_title' => esc_html__( 'Quality Wood Work' , 'bwdads-swiper-td' ),
						'bwdads_slide1_desce' => esc_html__( 'It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters.', 'bwdads-swiper-td' ),
						'bwdads_slide1_button1_text' => esc_html__( 'Our service' , 'bwdads-swiper-td' ),
						'bwdads_slide1_button1_link' => ['url' => 'https://bestwpdeveloper.com/'],
						'bwdads_slide1_button2_text' => esc_html__( 'Our service' , 'bwdads-swiper-td' ),
						'bwdads_slide1_button2_link' => ['url' => 'https://bestwpdeveloper.com/contact-us'],
						'bwdads_content_animations' => 'animate__fadeInUp',
						'bwdads_img_animations'   => 'animate__slideInRight',
						'bwdads_slidder1_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/bwd-vector.png',
                        ],
					],
					[
						'bwdads_slide1_title' => esc_html__( 'We Provide quality Services' , 'bwdads-swiper-td' ),
						'bwdads_slide1_sub_title' => esc_html__( 'Quality Wood Work' , 'bwdads-swiper-td' ),
						'bwdads_slide1_desce' => esc_html__( 'It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters.', 'bwdads-swiper-td' ),
						'bwdads_slide1_button1_text' => esc_html__( 'Our service' , 'bwdads-swiper-td' ),
						'bwdads_slide1_button1_link' => ['url' => 'https://bestwpdeveloper.com/'],
						'bwdads_slide1_button2_text' => esc_html__( 'Our service' , 'bwdads-swiper-td' ),
						'bwdads_slide1_button2_link' => ['url' => 'https://bestwpdeveloper.com/contact-us'],
						'bwdads_content_animations' => 'animate__fadeInUp',
						'bwdads_img_animations'   => 'animate__slideInRight',
						'bwdads_slidder1_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/bwd-vector.png',
                        ],
					],
					[
						'bwdads_slide1_title' => esc_html__( 'We Provide quality Services' , 'bwdads-swiper-td' ),
						'bwdads_slide1_sub_title' => esc_html__( 'Quality Wood Work' , 'bwdads-swiper-td' ),
						'bwdads_slide1_desce' => esc_html__( 'It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters.', 'bwdads-swiper-td' ),
						'bwdads_slide1_button1_text' => esc_html__( 'Our service' , 'bwdads-swiper-td' ),
						'bwdads_slide1_button1_link' => ['url' => 'https://bestwpdeveloper.com/'],
						'bwdads_slide1_button2_text' => esc_html__( 'Our service' , 'bwdads-swiper-td' ),
						'bwdads_slide1_button2_link' => ['url' => 'https://bestwpdeveloper.com/contact-us'],
						'bwdads_content_animations' => 'animate__fadeInUp',
						'bwdads_img_animations'   => 'animate__slideInRight',
						'bwdads_slidder1_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/bwd-vector.png',
                        ],
					],
				],
			]
		);

		$this->add_control(
            'slides_control_separator',
            [
                'type' => Controls_Manager::DIVIDER,
            ]
        );

		$this->add_responsive_control(
			'bwdads_slider_main_height',
			[
				'label' => esc_html__( 'Slider Height', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-wrapper' => 'height: {{SIZE}}{{UNIT}};',
				],
			]
		);

		$this->end_controls_section();




        $this->start_controls_section(
			'bwdads_slider_controls',
			[
				'label' => esc_html__( 'Slider Settings', 'bwdads-swiper-td' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);

		//Slide Effect
		$this->add_control(
			'bwdads_slider_effects',
			[
				'label' => esc_html__( 'Slide Effect', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'false',
				'options' => [
					'false'  => esc_html__( 'Slide', 'bwdads-swiper-td' ),
					'fade'  => esc_html__( 'Fade', 'bwdads-swiper-td' ),
					'coverflow'  => esc_html__( 'Cover Flow', 'bwdads-swiper-td' ),
					'cube'  => esc_html__( 'Cube', 'bwdads-swiper-td' ),
					'flip'  => esc_html__( 'Flip', 'bwdads-swiper-td' ),
					'cards'  => esc_html__( 'Cards', 'bwdads-swiper-td' ),
					'creative'  => esc_html__( 'Creative', 'bwdads-swiper-td' ),
				],
				'frontend_available' => true,
			]
		);

		//popover-Coverflow-coverflow
		$this->add_control(
			'bwdads_popover_slider_coverflow',
			[
				'label' => esc_html__( 'Coverflow Control', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdads-swiper-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdads-swiper-td' ),
				'return_value' => 'yes',
				'condition' => [
					'bwdads_slider_effects' => 'coverflow',
				],
			]
		);

		$this->start_popover();

			//Coverflow Rotate
			$this->add_control(
				'bwdads_coverflow_rotate',
				[
					'label' => esc_html__( 'Coverflow Rotate', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 0,
					'max' => 1000,
					'step' => 1,
					'default' => 50,
					'dynamic' => [
						'active' => true,
					],
					'frontend_available' => true,
				]
			);

			//Coverflow Depth
			$this->add_control(
				'bwdads_coverflow_depth',
				[
					'label' => esc_html__( 'Coverflow Depth', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 0,
					'max' => 1000,
					'step' => 1,
					'default' => 100,
					'dynamic' => [
						'active' => true,
					],
					'frontend_available' => true,
				]
			);

			//Coverflow Modifier
			$this->add_control(
				'bwdads_coverflow_modifier',
				[
					'label' => esc_html__( 'Coverflow Modifier', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 0,
					'max' => 1000,
					'step' => 1,
					'default' => 1,
					'dynamic' => [
						'active' => true,
					],
					'frontend_available' => true,
				]
			);

			//Coverflow shadow switcher
			$this->add_control(
				'bwdads_coverflow_shadow_switcher',
				[
					'label' => esc_html__( 'Coverflow Shadow', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => esc_html__( 'Yes', 'bwdads-swiper-td' ),
					'label_off' => esc_html__( 'No', 'bwdads-swiper-td' ),
					'return_value' => true,
					'default' => true,
					'frontend_available' => true,
				]
			);

			//Coverflow shadow
			$this->add_group_control(
				\Elementor\Group_Control_Background::get_type(),
				[
					'name' => 'bwdads_coverflow_shadow_left',
					'types' => [ 'classic', 'gradient'],
					'selector' => '{{WRAPPER}} .bwdads-swiper-slide-shadow-left, {{WRAPPER}} .bwdads-swiper-slide-shadow-right',
					'condition' => [
						'bwdads_coverflow_shadow_switcher' => true,
					],
					'frontend_available' => true,
				]
			);

		$this->end_popover();



		//popover-Coverflow-cube
		$this->add_control(
			'bwdads_popover_slider_cube',
			[
				'label' => esc_html__( 'Cube Control', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdads-swiper-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdads-swiper-td' ),
				'return_value' => 'yes',
				'condition' => [
					'bwdads_slider_effects' => 'cube',
				],
			]
		);
		$this->start_popover();

			//Cube shadow switcher
			$this->add_control(
				'bwdads_cube_shadow_switcher',
				[
					'label' => esc_html__( 'Cube Shadow', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => esc_html__( 'Yes', 'bwdads-swiper-td' ),
					'label_off' => esc_html__( 'No', 'bwdads-swiper-td' ),
					'return_value' => true,
					'default' => true,
					'frontend_available' => true,
				]
			);
			//Cube shadow
			$this->add_group_control(
				\Elementor\Group_Control_Background::get_type(),
				[
					'name' => 'bwdads_Cube_shadow',
					'types' => [ 'classic', 'gradient'],
					'selector' => '{{WRAPPER}} .bwdads-swiper-cube-shadow:before',
					'condition' => [
						'bwdads_cube_shadow_switcher' => true,
					],
				]
			);

			//Cube slide shadow switcher
			$this->add_control(
				'bwdads_cube_slide_shadow_switcher',
				[
					'label' => esc_html__( 'Cube Slide Shadow', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => esc_html__( 'Yes', 'bwdads-swiper-td' ),
					'label_off' => esc_html__( 'No', 'bwdads-swiper-td' ),
					'return_value' => true,
					'default' => true,
					'frontend_available' => true,
				]
			);
			//Cube shadow
			$this->add_group_control(
				\Elementor\Group_Control_Background::get_type(),
				[
					'name' => 'bwdads_Cube_slide_shadow',
					'types' => [ 'classic', 'gradient'],
					'selector' => '{{WRAPPER}} .bwdads-swiper-slide-shadow-left, {{WRAPPER}} .bwdads-swiper-slide-shadow-right',
					'condition' => [
						'bwdads_cube_slide_shadow_switcher' => true,
					],
				]
			);

			//Cube shadow offset
			$this->add_control(
				'bwdads_cube_shadow_offset',
				[
					'label' => esc_html__( 'Cube Shadow Offset', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 0,
					'max' => 1000,
					'step' => 1,
					'default' => 50,
					'dynamic' => [
						'active' => true,
					],
					'frontend_available' => true,
				]
			);

			//Cube Shadow Blur
			$this->add_control(
				'bwdads_Cube_shadow_blur',
				[
					'label'       => esc_html__('Cube Shadow Blur', 'bwdads-swiper-td'),
					'type'        => Controls_Manager::NUMBER,
					'min'         => 0,
					'max'         => 100,
					'step'        => 1,
					'default'     => 50,
					'selectors'   => [
						'{{WRAPPER}} .bwdads-swiper-cube-shadow:before' => 'filter: blur({{SIZE}}px)',
					],
				]
			);

		$this->end_popover();

		//slide speed
		$this->add_control(
			'bwdads_slide_speed',
			[
				'label' => esc_html__( 'Slide Speed (ms)', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::NUMBER,
				'min' => 0,
				'max' => 100000,
				'step' => 1,
				'default' => 1500,
				'dynamic' => [
					'active' => true,
				],
				'frontend_available' => true,
			]
		);

		//popover-responsive-device
		$this->add_control(
			'bwdads_popover_responsive_device',
			[
				'label' => esc_html__( 'Responsive Slider', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdads-swiper-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdads-swiper-td' ),
				'return_value' => 'yes',
				'frontend_available' => true,
			]
		);
		$this->start_popover();

			//desktop
			$this->add_control(
				'bwdads_slide_desktop_view',
				[
					'label' => esc_html__( 'Desktop View', 'bwdads-swiper-td' ),
					'description' => esc_html__('Notice: ( minimum - 1025px )', 'bwdads-swiper-td'),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 1,
					'max' => 100,
					'step' => 1,
					'default' => 1,
					'frontend_available' => true,
					'dynamic' => [
						'active' => true,
					],
				]
			);
			$this->add_control(
				'bwdads_desk_Space',
				[
					'label' => esc_html__( 'SpaceBetween', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 0,
					'max' => 500,
					'step' => 1,
					'default' => 0,
					'separator' => 'after',
					'frontend_available' => true,
					'dynamic' => [
						'active' => true,
					],
				]
			);

			//tablet
			$this->add_control(
				'bwdads_slide_tablet_view',
				[
					'label' => esc_html__( 'Tablet View', 'bwdads-swiper-td' ),
					'description' => esc_html__('Notice: ( 768px - 1024px )', 'bwdads-swiper-td'),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 1,
					'max' => 100,
					'step' => 1,
					'default' => 1,
					'frontend_available' => true,
					'dynamic' => [
						'active' => true,
					],
				]
			);
			$this->add_control(
				'bwdads_tablet_space',
				[
					'label' => esc_html__( 'SpaceBetween', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 0,
					'max' => 100,
					'step' => 1,
					'default' => 0,
					'separator' => 'after',
					'frontend_available' => true,
					'dynamic' => [
						'active' => true,
					],
				]
			);

			//mobile
			$this->add_control(
				'bwdads_slide_mobile_view',
				[
					'label' => esc_html__( 'Mobile View', 'bwdads-swiper-td' ),
					'description' => esc_html__('Notice: ( maximum - 767px )', 'bwdads-swiper-td'),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 1,
					'max' => 100,
					'step' => 1,
					'default' => 1,
					'frontend_available' => true,
					'dynamic' => [
						'active' => true,
					],
				]
			);
			$this->add_control(
				'bwdads_mobile_space',
				[
					'label' => esc_html__( 'SpaceBetween', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 0,
					'max' => 100,
					'step' => 1,
					'default' => 0,
					'frontend_available' => true,
					'dynamic' => [
						'active' => true,
					],
				]
			);

		$this->end_popover();

        //Slider Direction
		$this->add_control(
            'bwdads_slider_direction',
            [
                'label' => __('Slider Direction', 'bwdads-swiper-td'),
                'type' => Controls_Manager::SELECT,
                'default' => 'horizontal',
                'options' => [
                    'horizontal'  => __('Horizontal', 'bwdads-swiper-td'),
                    'vertical' => __('Vertical', 'bwdads-swiper-td'),
                ],
                'frontend_available' => true,
            ]
        );

        //Infinite Loop
        $this->add_control(
            'bwdads_loop_switcher',
            [
                'label' => esc_html__( 'Infinite Loop?', 'bwdads-swiper-td' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__( 'Yes', 'bwdads-swiper-td' ),
                'label_off' => esc_html__( 'No', 'bwdads-swiper-td' ),
                'return_value' => true,
                'default' => true,
				'frontend_available' => true,
            ]
        );

        //autoplay
        $this->add_control(
            'bwdads_autoslide_switcher',
            [
                'label' => esc_html__( 'Autoplay?', 'bwdads-swiper-td' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__( 'Yes', 'bwdads-swiper-td' ),
                'label_off' => esc_html__( 'No', 'bwdads-swiper-td' ),
                'return_value' => 'yes',
                'default' => 'yes',
				'frontend_available' => true,
            ]
        );

        //autoplay speed
		$this->add_control(
			'bwdads_slider_autoplay_speed',
			[
				'label' => esc_html__( 'Autoplay Speed (ms)', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::NUMBER,
				'min' => 0,
				'max' => 100000,
				'step' => 1,
                'default' => 5000,
                'dynamic' => [
                    'active' => true,
                ],
                'condition' => [
                    'bwdads_autoslide_switcher' => 'yes',
                ],
				'frontend_available' => true,
			]
		);

		//mousewheel
        $this->add_control(
            'bwdads_mousewheel',
            [
                'label' => esc_html__( 'Mousewheel?', 'bwdads-swiper-td' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__( 'Yes', 'bwdads-swiper-td' ),
                'label_off' => esc_html__( 'No', 'bwdads-swiper-td' ),
                'return_value' => true,
                'default' => true,
				'frontend_available' => true,
            ]
        );

        //scrollbar
		$this->add_control(
            'bwdads_scroll_bar',
            [
                'label' => __('Scroll Bar?', 'bwdads-swiper-td'),
                'type' => Controls_Manager::SWITCHER,
                'label_on' => __('Yes', 'bwdads-swiper-td'),
                'label_off' => __('No', 'bwdads-swiper-td'),
                'return_value' => 'yes',
                'default' => 'no',
                'frontend_available' => true,
            ]
        );

		//scrollbar show-hide
        $this->add_control(
            'bwdads_scroll_visibility',
            [
                'label' => __('Scroll Bar', 'bwdads-swiper-td'),
                'type' => Controls_Manager::SELECT,
                'default' => 'false',
                'options' => [
                    'false'  => __('Always show', 'bwdads-swiper-td'),
                    'true' => __('Automatic hide', 'bwdads-swiper-td'),
                ],
                'condition' => [
                    'bwdads_scroll_bar' => 'yes',
                ],
                'frontend_available' => true,
            ]
        );

        //Pagination
        $this->add_control(
            'bwdads_slide_pagination',
            [
                'label' => esc_html__( 'Pagination?', 'bwdads-swiper-td' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__( 'Show', 'bwdads-swiper-td' ),
                'label_off' => esc_html__( 'Hide', 'bwdads-swiper-td' ),
                'return_value' => 'yes',
                'default' => 'yes',
				'frontend_available' => true,
            ]
        );

        //bwdads_pagination_type
        $this->add_control(
            'bwdads_pagination_type',
            [
                'label' => esc_html__( 'Pagination Type', 'bwdads-swiper-td' ),
                'type' => \Elementor\Controls_Manager::SELECT,
                'default' => 'bullets',
                'options' => [
                    'bullets'  => esc_html__( 'Dots', 'bwdads-swiper-td' ),
					'numbers'  => esc_html__( 'Numbers', 'bwdads-swiper-td' ),
                    'progressbar'  => esc_html__( 'Progressbar', 'bwdads-swiper-td' ),
                    'fraction'  => esc_html__( 'Fraction', 'bwdads-swiper-td' ),
                ],
                'condition' => [
                    'bwdads_slide_pagination' => 'yes',
                ],
				'frontend_available' => true,
            ]
        );

        //Arrow Navigation
        $this->add_control(
            'bwdads_arrow_switcher',
            [
                'label' => esc_html__( 'Arrow Navigation?', 'bwdads-swiper-td' ),
                'type' => \Elementor\Controls_Manager::SWITCHER,
                'label_on' => esc_html__( 'Show', 'bwdads-swiper-td' ),
                'label_off' => esc_html__( 'Hide', 'bwdads-swiper-td' ),
                'return_value' => 'yes',
                'default' => 'yes',
				'frontend_available' => true,
            ]
        );

        //arrow type
        $this->add_control(
            'bwdads_nav_type',
            [
                'label' => esc_html__( 'Navigation Type', 'bwdads-swiper-td' ),
                'type' => \Elementor\Controls_Manager::SELECT,
                'default' => 'icon',
                'options' => [
                    'icon'  => esc_html__( 'Icon', 'bwdads-swiper-td' ),
                    'text'  => esc_html__( 'Text', 'bwdads-swiper-td' ),
                ],
                'condition' => [
                    'bwdads_arrow_switcher' => 'yes',
                ],
				'frontend_available' => true,
            ]
        );

        //popover Navigation icon
        $this->add_control(
			'bwdads_popover_navigation_icon',
			[
				'label' => esc_html__( 'Navigation Icon', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdads-swiper-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdads-swiper-td' ),
				'return_value' => 'yes',
                'condition' => [
                    'bwdads_nav_type' => 'icon',
                    'bwdads_arrow_switcher' => 'yes',
                ],
				'frontend_available' => true,
			]
		);
        $this->start_popover();

            //prev icon
			$this->add_control(
				'bwdads_nav_prev_arrow',
				[
					'label' => esc_html__( 'Previous Icon', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::ICONS,
					'default' => [
						'value' => 'fas fa-chevron-left',
						'library' => 'fa-solid',
					],
				]
			);
			//next icon
			$this->add_control(
				'bwdads_nav_next_arrow',
				[
					'label' => esc_html__( 'Next Icon', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::ICONS,
					'default' => [
						'value' => 'fas fa-chevron-right',
						'library' => 'fa-solid',
					],
				]
			);

        $this->end_popover();


        //popover Navigation text
        $this->add_control(
			'bwdads_popover_navigation_text',
			[
				'label' => esc_html__( 'Navigation Text', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdads-swiper-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdads-swiper-td' ),
				'return_value' => 'yes',
                'condition' => [
                    'bwdads_nav_type' => 'text',
                    'bwdads_arrow_switcher' => 'yes',
                ],
			]
		);
        $this->start_popover();

            //prev text
			$this->add_control(
				'bwdads_nav_prev_text',
				[
					'label' => esc_html__( 'Previous Text', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::TEXT,
					'default' => esc_html__( 'Prev', 'bwdads-swiper-td' ),
					'dynamic' => [
						'active' => true,
					],
				]
			);

            //next text
			$this->add_control(
				'bwdads_nav_next_text',
				[
					'label' => esc_html__( 'Next Text', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::TEXT,
					'default' => esc_html__( 'Next', 'bwdads-swiper-td' ),
					'dynamic' => [
						'active' => true,
					],
				]
			);

        $this->end_popover();



        $this->end_controls_section();


        $this->start_controls_section(
			'bwdads_slider_arrow_style',
			[
				'label' => esc_html__( 'Navigation :: Arrow', 'bwdads-swiper-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
                'condition' => [
                    'bwdads_arrow_switcher' => 'yes',
                ],
			]
		);

        //norlam-hover-tab
		$this->start_controls_tabs(
			'style_tabs',
		);

		//highlight-normal-style------------------------------------------
		$this->start_controls_tab(
			'style_normal_tab',
			[
				'label' => esc_html__( 'Normal', 'bwdads-swiper-td' ),
			]
		);

            //arrow-color
            $this->add_control(
                'bwdads_arrow_color',
                [
                    'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
                    'type' => \Elementor\Controls_Manager::COLOR,
                    'selectors' => [
                        '{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'color: {{VALUE}}',
                    ],
                ]
            );

			//arrow-background
			$this->add_group_control(
				\Elementor\Group_Control_Background::get_type(),
				[
					'name' => 'bwdads_arrow_background_color',
					'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
					'types' => [ 'classic', 'gradient'],
					'selector' => '{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev',
				]
			);

			//size
			$this->add_responsive_control(
				'bwdads_arrow_size',
				[
					'label' => esc_html__( 'Size', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'font-size: {{SIZE}}{{UNIT}};',
					],
                    'condition' => [
						'bwdads_nav_type' => 'icon',
					],
				]
			);

			//typography
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'bwdads_arrow_tetx_typography',
					'selector' => '{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev',
                    'condition' => [
						'bwdads_nav_type' => 'text',
					],
				]
			);

			//width
			$this->add_responsive_control(
				'bwdads_arrow_width',
				[
					'label' => esc_html__( 'Width', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'width: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//height
			$this->add_responsive_control(
				'bwdads_arrow_height',
				[
					'label' => esc_html__( 'Height', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'height: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//border
			$this->add_group_control(
				\Elementor\Group_Control_Border::get_type(),
				[
					'name' => 'bwdads_arrow_border',
					'label' => esc_html__( 'Border', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev',
				]
			);

			//Border Radius
			$this->add_responsive_control(
				'bwdads_arrow_border-radius',
				[
					'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//Box Shadow
			$this->add_group_control(
				\Elementor\Group_Control_Box_Shadow::get_type(),
				[
					'name' => 'bwdads_arrow_box-shadow',
					'label' => esc_html__( 'Box Shadow', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev',
				]
			);

			//opacity
			$this->add_control(
				'bwdads_arrow_opacity',
				[
					'label'       => esc_html__('Arrow Opacity', 'bwdads-swiper-td'),
					'type'        => Controls_Manager::NUMBER,
					'min'         => 0,
					'max'         => 100,
					'step'        => .1,
					'selectors'   => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'opacity: {{SIZE}}',
					],
				]
			);

			//visibility
			$this->add_responsive_control(
				'bwdads_slider_visibility',
				[
					'label'     => esc_html__('Visibility', 'bwdads-swiper-td'),
					'type'      => Controls_Manager::SELECT,
					'options'   => [
						'visible' => esc_html__('Visible', 'bwdads-swiper-td'),
						'hidden'  => esc_html__('Hidden', 'bwdads-swiper-td'),
					],
					'default'   => 'visible',
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'visibility: {{VALUE}}',
					],
				]
			);

			//popover-//Arrow Navigation
			$this->add_control(
				'bwdads_arrow_popover_style',
				[
					'label' => esc_html__( 'Position', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
					'label_off' => esc_html__( 'Default', 'bwdads-swiper-td' ),
					'label_on' => esc_html__( 'Custom', 'bwdads-swiper-td' ),
					'return_value' => 'yes',

				]
			);

			$this->start_popover();

				//left-arrow
				$this->add_control(
					'bwdads_arrow_left_heading',
					[
						'label' => esc_html__( 'Left Arrow', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::HEADING,
						'separator' => 'before',
					]
				);

				//top
				$this->add_responsive_control(
					'bwdads_arrow_left_position_vertical',
					[
						'label' => esc_html__( 'Vertical', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'top: {{SIZE}}{{UNIT}};',
						],
					]
				);

				//left
				$this->add_responsive_control(
					'bwdads_arrow_left_position_horizontal',
					[
						'label' => esc_html__( 'Horizontal', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'left: {{SIZE}}{{UNIT}};',
						],
					]
				);


				//right-arrow
				$this->add_control(
					'bwdads_arrow_right_heading',
					[
						'label' => esc_html__( 'Right Arrow', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::HEADING,
						'separator' => 'before',
					]
				);

				//top
				$this->add_responsive_control(
					'bwdads_arrow_Right_position_vertical',
					[
						'label' => esc_html__( 'Vertical', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next' => 'top: {{SIZE}}{{UNIT}};',
						],
					]
				);

				//right
				$this->add_responsive_control(
					'bwdads_arrow_right_position_horizontal',
					[
						'label' => esc_html__( 'Horizontal', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next' => 'right: {{SIZE}}{{UNIT}};',
						],
					]
				);

			$this->end_popover();

		$this->end_controls_tab();



		//highlight-hover-style------------------------------------------
		$this->start_controls_tab(
			'style_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwdads-swiper-td' ),
			]
		);

			//arrow-color
			$this->add_control(
				'bwdads_arrow_color_hover',
				[
					'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next:hover, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev:hover' => 'color: {{VALUE}}',
					],
				]
			);

			//arrow-background
			$this->add_group_control(
				\Elementor\Group_Control_Background::get_type(),
				[
					'name' => 'bwdads_arrow_background_color_hover',
					'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
					'types' => [ 'classic', 'gradient'],
					'selector' => '{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next:hover, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev:hover',
				]
			);

			//size
			$this->add_responsive_control(
				'bwdads_arrow_size_hover',
				[
					'label' => esc_html__( 'Size', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next:hover, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev:hover' => 'font-size: {{SIZE}}{{UNIT}};',
					],
                    'condition' => [
						'bwdads_nav_type' => 'icon',
					],
				]
			);

			//typography
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'bwdads_arrow_tetx_typography_hover',
					'selector' => '{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next:hover, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev:hover',
                    'condition' => [
						'bwdads_nav_type' => 'text',
					],
				]
			);

			//width
			$this->add_responsive_control(
				'bwdads_arrow_width_hover',
				[
					'label' => esc_html__( 'Width', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next:hover, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev:hover' => 'width: {{SIZE}}{{UNIT}};',
					],
				]
			);
			//height
			$this->add_responsive_control(
				'bwdads_arrow_height_hover',
				[
					'label' => esc_html__( 'Height', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 1,
						],
						'%' => [
							'min' => 0,
							'max' => 1000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next:hover, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev:hover' => 'height: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//border
			$this->add_group_control(
				\Elementor\Group_Control_Border::get_type(),
				[
					'name' => 'bwdads_arrow_border_hover',
					'label' => esc_html__( 'Border', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next:hover, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev:hover',
				]
			);

			//Border Radius
			$this->add_responsive_control(
				'bwdads_arrow_border-radius_hover',
				[
					'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%', 'em' ],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next:hover, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);

			//Box Shadow
			$this->add_group_control(
				\Elementor\Group_Control_Box_Shadow::get_type(),
				[
					'name' => 'bwdads_arrow_box-shadow_hover',
					'label' => esc_html__( 'Box Shadow', 'bwdads-swiper-td' ),
					'selector' => '{{WRAPPER}} .bwdads-swiper-button-next .bwdads-swiper-next:hover, {{WRAPPER}} .bwdads-swiper-button-prev .bwdads-swiper-prev:hover',
				]
			);

			//opacity
			$this->add_control(
				'bwdads_arrow_opacity_hover',
				[
					'label'       => esc_html__('Arrow Opacity', 'bwdads-swiper-td'),
					'type'        => Controls_Manager::NUMBER,
					'min'         => 0,
					'max'         => 100,
					'step'        => .1,
					'selectors'   => [
						'{{WRAPPER}} .bwdads-slider-common:hover .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-slider-common:hover .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'opacity: {{SIZE}}',
					],
				]
			);

			//visibility
			$this->add_responsive_control(
				'bwdads_photostack_visibility_hover',
				[
					'label'     => esc_html__('Visibility', 'bwdads-swiper-td'),
					'type'      => Controls_Manager::SELECT,
					'options'   => [
						'visible' => esc_html__('Visible', 'bwdads-swiper-td'),
						'hidden'  => esc_html__('Hidden', 'bwdads-swiper-td'),
					],
					'default'   => 'visible',
					'selectors' => [
						'{{WRAPPER}} .bwdads-slider-common:hover .bwdads-swiper-button-next .bwdads-swiper-next, {{WRAPPER}} .bwdads-slider-common:hover .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'visibility: {{VALUE}}',
					],
				]
			);

			//popover-//Arrow Navigation
			$this->add_control(
				'bwdads_arrow_popover_style_hover',
				[
					'label' => esc_html__( 'Position', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
					'label_off' => esc_html__( 'Default', 'bwdads-swiper-td' ),
					'label_on' => esc_html__( 'Custom', 'bwdads-swiper-td' ),
					'return_value' => 'yes',

				]
			);

			$this->start_popover();

				//left-arrow-heading
				$this->add_control(
					'bwdads_arrow_left_heading_hover',
					[
						'label' => esc_html__( 'Left Arrow', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::HEADING,
						'separator' => 'before',
					]
				);

				//top
				$this->add_responsive_control(
					'bwdads_arrow_left_position_vertical_hover',
					[
						'label' => esc_html__( 'Vertical', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdads-slider-common:hover .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'top: {{SIZE}}{{UNIT}};',
						],
					]
				);

				//left
				$this->add_responsive_control(
					'bwdads_arrow_left_position_horizontal_hover',
					[
						'label' => esc_html__( 'Horizontal', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdads-slider-common:hover .bwdads-swiper-button-prev .bwdads-swiper-prev' => 'left: {{SIZE}}{{UNIT}};',
						],
					]
				);


				//right-arrow-heading
				$this->add_control(
					'bwdads_arrow_right_heading_hover',
					[
						'label' => esc_html__( 'Right Arrow', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::HEADING,
						'separator' => 'before',
					]
				);

				//top
				$this->add_responsive_control(
					'bwdads_arrow_Right_position_vertical_hover',
					[
						'label' => esc_html__( 'Vertical', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdads-slider-common:hover .bwdads-swiper-button-next .bwdads-swiper-next' => 'top: {{SIZE}}{{UNIT}};',
						],
					]
				);

				//right
				$this->add_responsive_control(
					'bwdads_arrow_right_position_horizontal_hover',
					[
						'label' => esc_html__( 'Horizontal', 'bwdads-swiper-td' ),
						'type' => \Elementor\Controls_Manager::SLIDER,
						'size_units' => [ 'px', '%' ],
						'range' => [
							'px' => [
								'min' => -1000,
								'max' => 1000,
								'step' => 1,
							],
							'%' => [
								'min' => -1000,
								'max' => 1000,
							],
						],
						'selectors' => [
							'{{WRAPPER}} .bwdads-slider-common:hover .bwdads-swiper-button-next .bwdads-swiper-next' => 'right: {{SIZE}}{{UNIT}};',
						],
					]
				);

			$this->end_popover();

		$this->end_controls_tab();
		$this->end_controls_tabs();

        $this->end_controls_section();



		//Pagination :: Dots
        $this->start_controls_section(
			'bwdads_slider_dots_style',
			[
				'label' => esc_html__( 'Pagination :: Dots', 'bwdads-swiper-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
                'condition' => [
                    'bwdads_pagination_type' => 'bullets',
					'bwdads_slide_pagination' => 'yes',
                ],
			]
		);

		//popover-//dots Pagination
		$this->add_control(
			'bwdads_dots_popover_style',
			[
				'label' => esc_html__( 'Position', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdads-swiper-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdads-swiper-td' ),
				'return_value' => 'yes',

			]
		);

		$this->start_popover();

            //horizontal
			//bottom
			$this->add_responsive_control(
				'bwdads_dots_bottom_position_vertical',
				[
					'label' => esc_html__( 'Vertical', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -2000,
							'max' => 2000,
							'step' => 1,
						],
						'%' => [
							'min' => -2000,
							'max' => 2000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-pagination' => 'bottom: {{SIZE}}{{UNIT}};',
					],
                    'condition' => [
                        'bwdads_slider_direction' => 'horizontal',
                    ],
				]
			);

			//left
			$this->add_responsive_control(
				'bwdads_dots_left_position_horizontal',
				[
					'label' => esc_html__( 'Horizontal', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -2000,
							'max' => 2000,
							'step' => 1,
						],
						'%' => [
							'min' => -2000,
							'max' => 2000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-pagination' => 'left: {{SIZE}}{{UNIT}};',
					],
                    'condition' => [
                        'bwdads_slider_direction' => 'horizontal',
                    ],
				]
			);

            //vertical
            //top
			$this->add_responsive_control(
				'bwdads_dots_top_position_vertical',
				[
					'label' => esc_html__( 'Vertical', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -2000,
							'max' => 2000,
							'step' => 1,
						],
						'%' => [
							'min' => -2000,
							'max' => 2000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-pagination' => 'top: {{SIZE}}{{UNIT}};',
					],
                    'condition' => [
                        'bwdads_slider_direction' => 'vertical',
                    ],
				]
			);

			//right
			$this->add_responsive_control(
				'bwdads_dots_right_position_horizontal',
				[
					'label' => esc_html__( 'Horizontal', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -2000,
							'max' => 2000,
							'step' => 1,
						],
						'%' => [
							'min' => -2000,
							'max' => 2000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-pagination' => 'right: {{SIZE}}{{UNIT}};',
					],
                    'condition' => [
                        'bwdads_slider_direction' => 'vertical',
                    ],
				]
			);

		$this->end_popover();

		//dots-gap horizontal
		$this->add_responsive_control(
			'bwdads_dots_gap',
			[
				'label' => esc_html__( 'Dots Gap', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination .bwdads-swiper-pagination-bullet:not(:last-child)' => 'margin-right: {{SIZE}}{{UNIT}};',
				],
                'condition' => [
                    'bwdads_slider_direction' => 'horizontal',
                ],
			]
		);

		//dots-gap vertical
		$this->add_responsive_control(
			'bwdads_dots_gap_vartical',
			[
				'label' => esc_html__( 'Dots Gap', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination .bwdads-swiper-pagination-bullet:not(:last-child)' => 'margin-bottom: {{SIZE}}{{UNIT}};',
				],
                'condition' => [
                    'bwdads_slider_direction' => 'vertical',
                ],
			]
		);

		//alignment
		$this->add_responsive_control(
			'bwdads_dots_alignment',
			[
				'label' => esc_html__( 'Alignment', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::CHOOSE,
				'options' => [
					'left' => [
						'title' => esc_html__( 'Left', 'bwdads-swiper-td' ),
						'icon' => 'eicon-text-align-left',
					],
					'center' => [
						'title' => esc_html__( 'Center', 'bwdads-swiper-td' ),
						'icon' => 'eicon-text-align-center',
					],
					'right' => [
						'title' => esc_html__( 'Right', 'bwdads-swiper-td' ),
						'icon' => 'eicon-text-align-right',
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination' => 'text-align: {{VALUE}}',
				],
				'toggle' => true,
                'condition' => [
                    'bwdads_slider_direction' => 'horizontal',
                ],
			]
		);

		//norlam-hover-tab
		$this->start_controls_tabs(
			'style_tabs_dots',
            [
                'separator' => 'before',
            ]
		);

		//highlight-normal-style------------------------------------------
		$this->start_controls_tab(
			'style_normal_tab_dots',
			[
				'label' => esc_html__( 'Normal', 'bwdads-swiper-td' ),
			]
		);

		//dots-color
		$this->add_control(
			'bwdads_dots_number_color',
			[
				'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet .bwdads-paginumb' => 'color: {{VALUE}}',
				],
				'condition' => [
					'bwdads_pagination_type' => 'bullets',
					'bwdads_pagination_dots_number_type' => 'numbers',
				],
			]
		);

		//dots-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdads_dots_background_color',
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-bullet',
			]
		);

		//dots-typography
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdads_dots_number_typography',
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination .bwdads-swiper-pagination-bullet',
				'condition' => [
					'bwdads_pagination_type' => 'bullets',
					'bwdads_pagination_dots_number_type' => 'numbers',
				],
			]
		);

		//width
		$this->add_responsive_control(
			'bwdads_dots_width',
			[
				'label' => esc_html__( 'Width', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet ' => 'width: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//height
		$this->add_responsive_control(
			'bwdads_dots_height',
			[
				'label' => esc_html__( 'Height', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet' => 'height: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//border
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdads_dots_border',
				'label' => esc_html__( 'Border', 'bwdads-swiper-td' ),
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-bullet',
			]
		);

		//Border Radius
		$this->add_responsive_control(
			'bwdads_dots_border-radius',
			[
				'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdads_dots_box-shadow',
				'label' => esc_html__( 'Box Shadow', 'bwdads-swiper-td' ),
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-bullet',
			]
		);


		$this->end_controls_tab();



		//highlight-active-style------------------------------------------
		$this->start_controls_tab(
			'style_active_tab_dots',
			[
				'label' => esc_html__( 'Active', 'bwdads-swiper-td' ),
			]
		);

		//dots-color
		$this->add_control(
			'bwdads_dots_number_color_active',
			[
				'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet-active .bwdads-paginumb' => 'color: {{VALUE}}',
				],
				'condition' => [
					'bwdads_pagination_type' => 'bullets',
					'bwdads_pagination_dots_number_type' => 'numbers',
				],
			]
		);

		//dots-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdads_dots_background_color_active',
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-bullet.bwdads-swiper-pagination-bullet-active',
			]
		);

		//width
		$this->add_responsive_control(
			'bwdads_dots_width_active',
			[
				'label' => esc_html__( 'Width', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet.bwdads-swiper-pagination-bullet-active' => 'width: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//height
		$this->add_responsive_control(
			'bwdads_dots_height_active',
			[
				'label' => esc_html__( 'Height', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet.bwdads-swiper-pagination-bullet-active' => 'height: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//border
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdads_dots_border_active',
				'label' => esc_html__( 'Border', 'bwdads-swiper-td' ),
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-bullet.bwdads-swiper-pagination-bullet-active',
			]
		);

		//Border Radius
		$this->add_responsive_control(
			'bwdads_dots_border-radius_active',
			[
				'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet.bwdads-swiper-pagination-bullet-active' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdads_dots_box-shadow-active',
				'label' => esc_html__( 'Box Shadow', 'bwdads-swiper-td' ),
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-bullet.bwdads-swiper-pagination-bullet-active',
			]
		);

		$this->end_controls_tab();



		//highlight-hover-style------------------------------------------
		$this->start_controls_tab(
			'style_hover_tab_dots',
			[
				'label' => esc_html__( 'Hover', 'bwdads-swiper-td' ),
			]
		);

		//dots-color
		$this->add_control(
			'bwdads_dots_number_color_hover',
			[
				'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet .bwdads-paginumb:hover' => 'color: {{VALUE}}',
				],
				'condition' => [
					'bwdads_pagination_type' => 'bullets',
					'bwdads_pagination_dots_number_type' => 'numbers',
				],
			]
		);

		//dots-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdads_dots_background_color_hover',
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-bullet:hover',
			]
		);

		//width
		$this->add_responsive_control(
			'bwdads_dots_width_hover',
			[
				'label' => esc_html__( 'Width', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet:hover' => 'width: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//height
		$this->add_responsive_control(
			'bwdads_dots_height_hover',
			[
				'label' => esc_html__( 'Height', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet:hover' => 'height: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//border
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdads_dots_border_hover',
				'label' => esc_html__( 'Border', 'bwdads-swiper-td' ),
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-bullet:hover',
			]
		);

		//Border Radius
		$this->add_responsive_control(
			'bwdads_dots_border-radius_hover',
			[
				'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-bullet:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdads_dots_box-shadow-hover',
				'label' => esc_html__( 'Box Shadow', 'bwdads-swiper-td' ),
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-bullet:hover',
			]
		);

		$this->end_controls_tab();
		$this->end_controls_tabs();

		$this->end_controls_section();



		$this->start_controls_section(
			'bwdads_slider_progressbar_style',
			[
				'label' => esc_html__( 'Pagination :: Progressbar', 'bwdads-swiper-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
                'condition' => [
                    'bwdads_pagination_type' => 'progressbar',
					'bwdads_slide_pagination' => 'yes',
                ],
			]
		);

		//norlam-hover-tab
		$this->start_controls_tabs(
			'style_tabs_progressbar',
		);

		//highlight-normal-style------------------------------------------
		$this->start_controls_tab(
			'style_normal_tab_progressbar',
			[
				'label' => esc_html__( 'Normal', 'bwdads-swiper-td' ),
			]
		);

		//Height
		$this->add_responsive_control(
			'bwdads_progressbar_height',
			[
				'label' => esc_html__( 'height', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-progressbar' => 'height: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'bwdads_slider_direction' => 'horizontal',
				],
			]
		);

		//width
		$this->add_responsive_control(
			'bwdads_progressbar_width',
			[
				'label' => esc_html__( 'width', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-progressbar' => 'width: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'bwdads_slider_direction' => 'vertical',
				],
			]
		);

		//progressbar-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdads_progressbar_background_color',
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-progressbar',
			]
		);

		$this->end_controls_tab();



		//highlight-active-style------------------------------------------
		$this->start_controls_tab(
			'style_active_tab_progressbar',
			[
				'label' => esc_html__( 'Active', 'bwdads-swiper-td' ),
			]
		);

		//progressbar-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdads_progressbar_background_color_active',
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-progressbar .bwdads-swiper-pagination-progressbar-fill',
			]
		);

		$this->end_controls_tab();
		$this->end_controls_tabs();

		$this->end_controls_section();



		$this->start_controls_section(
			'bwdads_slider_fraction_style',
			[
				'label' => esc_html__( 'Pagination :: Fraction', 'bwdads-swiper-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
                'condition' => [
                    'bwdads_pagination_type' => 'fraction',
					'bwdads_slide_pagination' => 'yes',
                ],
			]
		);

		//popover-//fraction Pagination
		$this->add_control(
			'bwdads_fraction_popover_style',
			[
				'label' => esc_html__( 'Position', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::POPOVER_TOGGLE,
				'label_off' => esc_html__( 'Default', 'bwdads-swiper-td' ),
				'label_on' => esc_html__( 'Custom', 'bwdads-swiper-td' ),
				'return_value' => 'yes',

			]
		);

		$this->start_popover();

			//bottom
			$this->add_responsive_control(
				'bwdads_fraction_bottom_position',
				[
					'label' => esc_html__( 'Vertical', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -2000,
							'max' => 2000,
							'step' => 1,
						],
						'%' => [
							'min' => -2000,
							'max' => 2000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-pagination-fraction' => 'bottom: {{SIZE}}{{UNIT}};',
					],
				]
			);

			//left
			$this->add_responsive_control(
				'bwdads_fraction_left_position',
				[
					'label' => esc_html__( 'Horizontal', 'bwdads-swiper-td' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -2000,
							'max' => 2000,
							'step' => 1,
						],
						'%' => [
							'min' => -2000,
							'max' => 2000,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .bwdads-swiper-pagination-fraction' => 'left: {{SIZE}}{{UNIT}};',
					],
				]
			);

		$this->end_popover();

		//Fraction-width
		$this->add_responsive_control(
			'bwdads_fraction_width',
			[
				'label' => esc_html__( 'Width', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-fraction span' => 'width: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//Fraction-height
		$this->add_responsive_control(
			'bwdads_fraction_height',
			[
				'label' => esc_html__( 'Height', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-fraction span' => 'height: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//Fraction-gap horizontal
		$this->add_responsive_control(
			'bwdads_fraction_gap',
			[
				'label' => esc_html__( 'Fraction Gap', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-fraction' => 'gap: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//alignment
		$this->add_responsive_control(
			'bwdads_fraction_alignment',
			[
				'label' => esc_html__( 'Alignment', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::CHOOSE,
				'options' => [
					'start' => [
						'title' => esc_html__( 'Left', 'bwdads-swiper-td' ),
						'icon' => 'eicon-text-align-left',
					],
					'center' => [
						'title' => esc_html__( 'Center', 'bwdads-swiper-td' ),
						'icon' => 'eicon-text-align-center',
					],
					'end' => [
						'title' => esc_html__( 'Right', 'bwdads-swiper-td' ),
						'icon' => 'eicon-text-align-right',
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-fraction' => 'justify-content: {{VALUE}}',
				],
			]
		);

		//fraction-color
		$this->add_control(
			'bwdads_fraction_number_color',
			[
				'label' => esc_html__( 'Color', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-fraction span' => 'color: {{VALUE}}',
				],
			]
		);

		//fraction-active-color
		$this->add_control(
			'bwdads_fraction_number_active_color',
			[
				'label' => esc_html__( 'Active Color', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-fraction span.bwdads-swiper-pagination-current' => 'color: {{VALUE}}',
				],
			]
		);

		//typography
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'bwdads_fraction_typography',
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-fraction span',
			]
		);

		//fraction-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdads_fraction_background_color',
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-fraction span',
			]
		);

		//border
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdads_faction_border',
				'label' => esc_html__( 'Border', 'bwdads-swiper-td' ),
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-fraction span',
			]
		);

		//Border Radius
		$this->add_responsive_control(
			'bwdads_faction_border-radius',
			[
				'label' => esc_html__( 'Border Radius', 'bwdads-swiper-td' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .bwdads-swiper-pagination-fraction span' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdads_faction_box-shadow',
				'label' => esc_html__( 'Box Shadow', 'bwdads-swiper-td' ),
				'selector' => '{{WRAPPER}} .bwdads-swiper-pagination-fraction span',
			]
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'bwdads_scrollbar_style',
			[
				'label' => esc_html__( 'Scroll Bar', 'bwdads-swiper-td' ),
				'tab' => Controls_Manager::TAB_STYLE,
                'condition' => [
                    'bwdads_scroll_bar' => 'yes',
                ],
			]
		);

		//fraction-background
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'bwdads_scrollbar_background',
				'label' => esc_html__( 'Background', 'bwdads-swiper-td' ),
				'types' => [ 'classic', 'gradient'],
				'selector' => '{{WRAPPER}} .bwdads-swiper-scrollbar-drag',
			]
		);

		$this->end_controls_section();




	}

	protected function render() {
		$settings = $this->get_settings_for_display();
		

		?>

		<div class="bwd_sliderDesign_1 bwdads-slider-common bwd-slider-widget-wrapper"> 
			<div class="bwdads-swiper bwdads-mySwiper">
				<div class="bwdads-swiper-wrapper">

					<?php if ( $settings['bwdads_slide1_repet'] ) { 
						foreach (  $settings['bwdads_slide1_repet'] as $slide1 ) {
							
						$animation_class = (isset($slide1['bwdads_content_animations']) && ($slide1['bwdads_content_animations'] != 'none')) ? $slide1['bwdads_content_animations'] : '';

						$animation_classimg = (isset($slide1['bwdads_img_animations']) && ($slide1['bwdads_img_animations'] != 'none')) ? $slide1['bwdads_img_animations'] : '';
					?>
					
					<div class="bwdads-swiper-slide bwd_single_slider elementor-repeater-item-<?php echo esc_attr( $slide1['_id'] ); ?>">
						<div class="bwd_content-wrap elementor-repeater-item-<?php echo esc_attr( $slide1['_id'] ); ?>">
							<div class="bwd_main-content bwdads-slide-content elementor-repeater-item-<?php echo esc_attr( $slide1['_id'] ); ?> <?php echo esc_attr($animation_class); ?>">
							<?php if (!empty($slide1['bwdads_slide1_title'])) : ?>
								<div class="bwd_main-title"><?php echo esc_html( $slide1['bwdads_slide1_title'] );?></div>
							<?php endif; ?>
							<?php if (!empty($slide1['bwdads_slide1_sub_title'])) : ?>							
								<div class="bwd_sub-title"><?php echo esc_html( $slide1['bwdads_slide1_sub_title'] ); ?></div>
							<?php endif; ?>
							<?php if (!empty($slide1['bwdads_slide1_desce'])) : ?>
								<div class="bwd_sub-desc"><?php echo esc_html( $slide1['bwdads_slide1_desce'] ); ?></div>
							<?php endif; ?>
								<div class="bwd_slide_button">
								<?php if (!empty($slide1['bwdads_slide1_button1_text'])) : ?>
									<a class="bwd_link_btn bwd-button1" href="<?php echo esc_url(isset($slide1['bwdads_slide1_button1_link']['url']) ? $slide1['bwdads_slide1_button1_link']['url'] : ''); ?>" <?php echo esc_attr(($slide1['bwdads_slide1_button1_link']['is_external']) ? 'target="_blank"' : ''); ?>><?php echo esc_html($slide1['bwdads_slide1_button1_text']); ?></a>
								<?php endif; ?>
								<?php if (!empty($slide1['bwdads_slide1_button2_text'])) : ?>
									<a class="bwd_link_btn bwd-button2" href="<?php echo esc_url(isset($slide1['bwdads_slide1_button2_link']['url']) ? $slide1['bwdads_slide1_button2_link']['url'] : ''); ?>" <?php echo esc_attr(($slide1['bwdads_slide1_button2_link']['is_external']) ? 'target="_blank"' : ''); ?>><?php echo esc_html($slide1['bwdads_slide1_button2_text']); ?></a>
								<?php endif; ?>
								</div>
							</div>

							<?php if(!empty($slide1['bwdads_slider1_img_switcher'] == 'yes')) : ?>
							<div class="bwd-slider-image elementor-repeater-item-<?php echo esc_attr( $slide1['_id'] ); ?>">
								<div class="bwd-img-wrap">
									<img class="bwdads-slide-img <?php echo esc_attr($animation_classimg); ?>" src="<?php echo esc_url( $slide1['bwdads_slidder1_image']['url'] ); ?>">
								</div>
							</div>
							<?php endif; ?>
						</div>
					</div>

					<?php } } ?>

				</div> 
				<?php require 'bwdads-swiper.php';?> 
			</div>
		</div>

		<?php
	}
}
